const ____Data____ = require("./packet");


/**
 * 检查http请求中的必要文件
 * @param {"对象类型：要验证的对象"}     args_Object
 * @param {"数组类型：要验证的字段"}     args_Fields
 * @param {"回调函数：可以传入null"}     args_Callback
 */
module.exports.do_Check_RequiredFile = (args_Object, args_Fields, args_Callback) => {
	let temp_Lose = new Array();
	args_Fields.forEach(element => {

		/**
		 * in 操作符 先搜索【实例本身】的属性，没有再搜索【原型】的属性
		 * hasOwnProperty()函数 只搜索【实例本身】的属性。
		 * delete 操作符 只删除【实例本身】的属性
		 */

		if (!args_Object.hasOwnProperty(element)) {
			temp_Lose.push(element);
		}
		else if (args_Object[element] == null) {
			temp_Lose.push(element);
		}
		else {
			if (typeof (args_Object[element]) != "object") {
				temp_Lose.push(element);
			}
			else {
				if (
					args_Object[element].hasOwnProperty("size")
					&&
					args_Object[element].hasOwnProperty("type")
					&&
					args_Object[element].hasOwnProperty("path")
					&&
					args_Object[element].hasOwnProperty("name")
				) {
					/**
					 * 此情况说明是合法的file中的文件
					 */
				}
				else {
					temp_Lose.push(element);
				}
			}
		}
	});

	if (temp_Lose.length > 0) {
		/**
		 * 参数重复是指：
		 * http使用KeyValue编码的时候，使用重复（多个相同）的key值来表达数组
		 */

		let temp_Packet = ____Data____.do_DataPacket("fail", "required_file_are_missing", temp_Lose.join(","));
		if (args_Callback != null) {
			args_Callback(temp_Packet);
		}
		return temp_Packet;
	}
	else {
		let temp_Packet = ____Data____.do_DataPacket("0000", null, null);
		return temp_Packet;
	}
}

/**
 * 检查http请求中的必要参数
 * @param {"对象类型：要验证的对象"}     args_Object
 * @param {"数组类型：要验证的字段"}     args_Fields
 * @param {"字符类型：验证级别【owner_key|not_null|not_blank】"}     args_CheckLevel
 * @param {"回调函数：可以传入null"}     args_Callback
 */
module.exports.do_Check_Propertys = (args_Object, args_Fields, args_CheckLevel, args_Callback) => {
	let temp_Lose = new Array();
	args_Fields.forEach(element => {

		/**
		 * in 操作符 先搜索【实例本身】的属性，没有再搜索【原型】的属性
		 * hasOwnProperty()函数 只搜索【实例本身】的属性。
		 * delete 操作符 只删除【实例本身】的属性
		 */

		if (Array.isArray(element)) {//认为是或的关系，存在一个就可以
			let temp_Exist = false;
			for (let p = 0; p < element.length; p++) {
				if (false) {

				}
				else if (args_CheckLevel == "owner_key") {
					temp_Exist = ((args_Object.hasOwnProperty(element[p])));
				}
				else if (args_CheckLevel == "not_null") {
					temp_Exist = ((args_Object.hasOwnProperty(element[p])) && (null != args_Object[element[p]]));
				}
				else if (args_CheckLevel == "not_blank") {
					temp_Exist = ((args_Object.hasOwnProperty(element[p])) && (null != args_Object[element[p]]) && ("" != args_Object[element[p]]));
				}
				if (true == temp_Exist) {
					break;
				}
			}
			if (false == temp_Exist) {
				temp_Lose.push(element.join("|"));
			}
		}
		else {
			if (false) {

			}
			else if (args_CheckLevel == "owner_key") {
				temp_Exist = ((args_Object.hasOwnProperty(element)));
			}
			else if (args_CheckLevel == "not_null") {
				temp_Exist = ((args_Object.hasOwnProperty(element)) && (null != args_Object[element]));
			}
			else if (args_CheckLevel == "not_blank") {
				temp_Exist = ((args_Object.hasOwnProperty(element)) && (null != args_Object[element]) && ("" != args_Object[element]));
			}
			if (false == temp_Exist) {
				temp_Lose.push(element);
			}
		}
	});

	if (temp_Lose.length > 0) {
		/**
		 * 参数重复是指：
		 * http使用KeyValue编码的时候，使用重复（多个相同）的key值来表达数组
		 */

		let temp_Packet = ____Data____.do_DataPacket("fail", "required_name_are_missing", temp_Lose.join(","));
		if (args_Callback != null) {
			args_Callback(temp_Packet);
		}
		return temp_Packet;
	}
	else {
		let temp_Packet = ____Data____.do_DataPacket("0000", null, null);
		return temp_Packet;
	}
}

/**
 * 检查http请求中的必要参数
 * @param {"对象类型：要验证的对象"}     args_Object
 * @param {"数组类型：要验证的字段"}     args_Fields
 * @param {"回调函数：可以传入null"}     args_Callback
 */
module.exports.do_Check_RequiredName = (args_Object, args_Fields, args_Callback) => {
	let temp_Lose = new Array();
	args_Fields.forEach(element => {

		/**
		 * in 操作符 先搜索【实例本身】的属性，没有再搜索【原型】的属性
		 * hasOwnProperty()函数 只搜索【实例本身】的属性。
		 * delete 操作符 只删除【实例本身】的属性
		 */

		if (Array.isArray(element)) {//认为是或的关系，存在一个就可以
			let temp_Exist = false;
			for (let p = 0; p < element.length; p++) {
				temp_Exist = module.exports.do_Check_Pairs(args_Object, element[p]);
				if (temp_Exist) {
					break;
				}
			}
			if (!temp_Exist) {
				temp_Lose.push(element.join("|"));
			}
		}
		else {
			if (!args_Object.hasOwnProperty(element)) {
				temp_Lose.push(element);
			}
			else if (args_Object[element] == null) {
				temp_Lose.push(element);
			}
			else {
				// if (Array.isArray(args_DataSource[element])) {
				// 	/**
				// 	 * 认为是不合格
				// 	 * 如果【content-type】=x-www-form-urlencoded，那么body中的重复的key作为数组来对待，这是http的规则，但是通常没有这么使用，也没有多少人知道这个规则
				// 	 */
				// 	temp_Lose.push(element);
				// }

				if (args_Object[element] == null) {
					{
						temp_Lose.push(element);
					}
				}
				else if (Number.isNaN(args_Object[element])) {
					{
						temp_Lose.push(element);
					}
				}
				else if (typeof (args_Object[element]) == "string") {
					if (args_Object[element].trim() == "") {
						temp_Lose.push(element);
					}
				}
			}
		}
	});

	if (temp_Lose.length > 0) {
		/**
		 * 参数重复是指：
		 * http使用KeyValue编码的时候，使用重复（多个相同）的key值来表达数组
		 */

		let temp_Packet = ____Data____.do_DataPacket("fail", "required_name_are_missing", temp_Lose.join(","));
		if (args_Callback != null) {
			args_Callback(temp_Packet);
		}
		return temp_Packet;
	}
	else {
		let temp_Packet = ____Data____.do_DataPacket("0000", null, null);
		return temp_Packet;
	}
}

/**
 * 如果给定的key在对象中，【存在】&&【不为null】&&【不为""】，则返回true，否则返回false
 * @param {"对象类型：要验证的对象"}     args_Object
 * @param {"字符类型：要验证的字段"}     args_Field
 */
module.exports.do_Check_Pairs = (args_Object, args_Field) => {
	if (false == args_Object.hasOwnProperty(args_Field)) {
		return false;
	}
	if (args_Object[args_Field] == null) {
		return false;
	}
	if (typeof (args_Object[args_Field]) == "string") {
		if (args_Object[args_Field].trim() == "") {
			return false;
		}
	}

	return true;
}

/**
 * 校验是否符合电子邮件格式，符合返回true，否则返回false
 * @param {"邮件地址"}      args_Mail_Address
 */
module.exports.do_Check_Mail_Address = (args_Mail_Address) => {

	if (args_Mail_Address.indexOf("@") == -1) {
		return false;
	}
	let temp_Spa2 = args_Mail_Address.split("@");
	if (temp_Spa2.length != 2) {
		return false;
	}

	let temp_Illigal = false;
	temp_Illigal = module.exports.do_Check_Mail_Section(temp_Spa2[0]);
	if (!temp_Illigal) {
		return false;
	}


	if (temp_Spa2[1].indexOf(".") == -1) {
		return false;
	}
	let temp_Spa3 = temp_Spa2[1].split(".");
	if (temp_Spa3.length < 2) {
		return false;
	}

	for (let i = 0; i < temp_Spa3.length; i++) {
		temp_Illigal = module.exports.do_Check_Mail_Section(temp_Spa3[i]);
		if (!temp_Illigal) {
			return false;
		}
	}
	return true;
}

module.exports.do_Check_Mail_Section = (args_Mail_Section) => {

	if (args_Mail_Section == "") {
		return false;
	}

	const temp_Ascii = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	const temp_Array = temp_Ascii.split("");
	const temp_Allow = [".", "-", "_"]


	if (!temp_Array.includes(args_Mail_Section[0])) {
		return false;
	}
	if (!temp_Array.includes(args_Mail_Section[args_Mail_Section.length - 1])) {
		return false;
	}
	if (args_Mail_Section.indexOf("..") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("--") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("-.") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("-_") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf(".-") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("._") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("_-") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("_.") > -1) {
		return false;
	}

	let temp_Char = "";
	let temp_clud = false;
	for (let i = 0; i < args_Mail_Section.length; i++) {
		temp_Char = args_Mail_Section[i];
		temp_clud = temp_Array.includes(temp_Char);
		if (!temp_clud) {
			if (!temp_Allow.includes(temp_Char)) {
				return false;
			}
		}
	}
	return true;
}

/**
 * 仅保留指定的字段
 * @param {"对象类型：要处理的对象"}     args_Object
 * @param {"数组类型：要保留的字段"}     args_Fields
*/
module.exports.do_FieldsRetain = (args_Object, args_Fields) => {
	let temp_Keys = Object.keys(args_Object);
	for (let i = 0; i < temp_Keys.length; i++) {
		if (false == args_Fields.includes(temp_Keys[i])) {
			delete (args_Object[temp_Keys[i]]);
		}
	}
}
/**
 * 仅删除指定的字段
 * @param {"对象类型：要处理的对象"}     args_Object
 * @param {"数组类型：要删除的字段"}     args_Fields
*/
module.exports.do_FieldsRemove = (args_Object, args_Fields) => {
	let temp_Keys = Object.keys(args_Object);
	for (let i = 0; i < temp_Keys.length; i++) {
		if (true == args_Fields.includes(temp_Keys[i])) {
			delete (args_Object[temp_Keys[i]]);
		}
	}
}
